var Sequelize = require("sequelize");

var sequelize = new Sequelize('lape', 'lape', 'lape', {
  host: "localhost",
  port: 3306
});

var User = sequelize.define('User', {
  id: { type: Sequelize.INTEGER, autoIncrement: true, primaryKey: true },
  username: { type: Sequelize.STRING, unique: true },
  password: Sequelize.STRING,
  is_active: { type: Sequelize.BOOLEAN, allowNull: false, defaultValue: true }
},{
  classMethods: {
    retrieveByUsername: function(username, success, failure){ 
      User.find({ where: {username: username} }).on('success', function(user) {
    	  if(success) {
    		  success(user);
    	  }
      }).on('failure', function(e) {
          if(failure) {
        	  failure(e);
          }
      });
    }
  },
  instanceMethods: {
    activate: function(success, failure) { 
      this.updateAttributes({
        is_active: true
      }).on('success', function() {
          if(success) success(this);
      }).on('failure', function() {
    	  if(failure) failure(this);  
      });
    }
  }
});

module.exports.activate = function(username, success, failure) {
  User.retrieveByUsername(username, function(user, success, failure){
    user.activate(success, failure);
  });
}

sequelize.sync();
